import firebase from 'firebase/app';
import 'firebase/auth';
import React, { FC } from 'react';
interface AuthProviderValue {
    user?: firebase.User;
    loading: boolean;
}
export declare const AuthContext: React.Context<AuthProviderValue>;
export interface AuthProviderProps {
    noPersistence?: boolean;
    onLogin?: (user: firebase.User, credential?: firebase.auth.OAuthCredential) => Promise<any>;
    onError?: (e: firebase.FirebaseError) => void;
}
export declare const AuthProvider: FC<AuthProviderProps>;
export declare function useAuthData(): AuthProviderValue;
export declare const withAuthProvider: (config: AuthProviderProps, Comp: React.ComponentType<{}>) => (p: any) => JSX.Element;
export {};
