"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var app_1 = __importDefault(require("firebase/app"));
require("firebase/auth");
var react_1 = __importStar(require("react"));
var react_use_promise_1 = __importDefault(require("react-use-promise"));
exports.AuthContext = react_1.createContext({
    loading: false,
});
exports.AuthProvider = function (props) {
    var children = props.children, onLogin = props.onLogin, onError = props.onError, noPersistence = props.noPersistence;
    react_1.useLayoutEffect(function () {
        if (noPersistence) {
            app_1.default.auth().setPersistence(app_1.default.auth.Auth.Persistence.NONE);
        }
    }, []);
    var user = useAuth().user;
    var _a = react_use_promise_1.default(function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, user_1, credential, operationType, e_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 4, , 6]);
                    return [4 /*yield*/, app_1.default.auth().getRedirectResult()];
                case 1:
                    _a = _b.sent(), user_1 = _a.user, credential = _a.credential, operationType = _a.operationType;
                    if (!(user_1 && onLogin)) return [3 /*break*/, 3];
                    console.log('received user, calling onLogin');
                    return [4 /*yield*/, onLogin(user_1, credential)];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3: return [3 /*break*/, 6];
                case 4:
                    e_1 = _b.sent();
                    return [4 /*yield*/, onError(e_1)];
                case 5:
                    _b.sent();
                    return [2 /*return*/];
                case 6: return [2 /*return*/];
            }
        });
    }); }, []), result = _a[0], error = _a[1], state = _a[2];
    var value = {
        user: user,
        loading: state === 'pending',
    };
    return react_1.default.createElement(exports.AuthContext.Provider, { value: value }, children);
};
function useAuthData() {
    return react_1.useContext(exports.AuthContext);
}
exports.useAuthData = useAuthData;
exports.withAuthProvider = function (config, Comp) {
    return function (p) { return (react_1.default.createElement(exports.AuthProvider, __assign({}, config),
        react_1.default.createElement(Comp, __assign({}, p)))); };
};
function useAuth() {
    var _a = react_1.useState(undefined), user = _a[0], setUser = _a[1];
    react_1.useLayoutEffect(function () {
        if (!app_1.default.apps.length) {
            console.error('you must call firebase.auth().initializeApp() before using firebase-react-components');
        }
    }, []);
    react_1.useEffect(function () {
        var listener = app_1.default.auth().onAuthStateChanged(function (user) {
            setUser(user);
            // alert('auth state changed ' + JSON.stringify(user))
        }, function (e) { return alert(e.message); });
        return function () { return listener(); };
    });
    return {
        user: user,
    };
}
